package
{
	import flash.events.Event;
	import flash.text.Font;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class RowTextField extends TextField
	{
		private var FontClass:Class;
		private var _size:Number;
		private var _color:uint;
		private var _letterSpace:Number;
		public var temptext:String ="";
		public var charIndex:Number=0;
		public var MOTION_COMPLETE:String="motion_complete";
		public var motionflg:Boolean =false;
		
		public function RowTextField(font:Class,size:Number=30,color:uint=0x13a062 ,letterSpace:Number=0)
		{
			FontClass = font;
			_size=size;
			_color=color;
			_letterSpace=letterSpace;
			
			this.createTextField();
		}
		
		private function createTextField():void {
			var font:Font = new FontClass();
			var format:TextFormat = new TextFormat(font.fontName , _size , _color);
			format.letterSpacing = _letterSpace;
			defaultTextFormat = format;
			embedFonts = true;
			autoSize = "left";
			selectable = false;
		}
		
		public function SetText(strChar:String , maxWidth:Number , ratio:Number=1):void {
			this.text = "";
			while(this.width < maxWidth) {
				var str:String;
				var tempratio:Number = Math.random();
				if(tempratio < ratio){
					str = strChar.charAt(Math.floor(Math.random()*strChar.length));
				} else {
					str = " ";
				}
				this.appendText(str);
			}
		}
		
		public function SetMotionText(strTitleChar:String , strChar:String , maxWidth:Number , ratio:Number=1):void {
			if (motionflg) return;
			this.text = temptext;
			while(this.width < maxWidth) {
				var str:String;
				var tempratio:Number = Math.random();
				if(tempratio < ratio){
					str = strChar.charAt(Math.floor(Math.random()*strChar.length));
				} else {
					var tempratio2:Number = Math.floor(charIndex / strTitleChar.length-1);
					tempratio2 = (tempratio2==-1) ? 0.8 : tempratio2;
					if(Math.random() < tempratio2){
						str = strTitleChar.charAt(Math.floor(Math.random()*strTitleChar.length));
					} else {
						str=" ";
					}
				}
				
				var idx:Number = Math.floor(Math.random() * temptext.length);
				var temp1:String = this.text.substring(0,idx);
				var temp2:String = this.text.substring(idx);
				var tempratio3:Number = Math.random();
				if ( tempratio3 < 0.28) {
					this.text = str + temp1 + temp2;
				} else if( tempratio3 >= 0.28 && tempratio3 < 0.50) {
					this.text = temp1 + str + temp2;
				} else {
					this.text = temp1 + temp2 + str;
				}
				
			}
			
			if( charIndex < strTitleChar.length) {
				if(this.text.search(strTitleChar.charAt(charIndex))>=0){
					temptext += strTitleChar.charAt(charIndex);
					charIndex++;
					if( charIndex == strTitleChar.length) {
						this.text = temptext;
						this.alignCenter(maxWidth);
						motionflg =true;
						dispatchEvent(new Event(this.MOTION_COMPLETE));
					}
				}
			}
		}
		
		public function initClear():void {
			temptext = "";
			charIndex = 0;
			motionflg = false;
		}
		
		private function alignCenter(maxWidth:Number):void {
			var cnt:Number = 0;
			while(this.width < maxWidth) {
				var str:String = this.text;
				if(cnt%2 == 0){
					this.text = " " + str;
				} else {
					this.text = str + " ";
				}
				cnt++;
			}
		}
	}
}