package {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.filters.BlurFilter;
	import flash.filters.GlowFilter;
	import flash.geom.Matrix;
	import flash.utils.Timer;
	
	import mx.core.BitmapAsset;
	
	[SWF(frameRate="60" , width="640" , height="480" , backgroundColor="0x0")]
	public class ghost_in_the_shell01 extends Sprite
	{
		public var ArnoPro:Class;
		[Embed(source="images/Texture.png")]
		public var Texture:Class;
		public const FONTSET_COMPLETE:String = "fontset_complete";
		public const TEXTSET_COMPLETE:String = "textset_complete";
		public var motionFlg:Boolean =false;
		private var _strChar:String = "0123456789";
		private var _strCharRatio:Number =1;
		private var _strCharRatioSpeed:Number =0;
		private var _txtSprite:Sprite;
		private var _txtArray:Array;
		private var _textAreaWidth:Number = 640;
		private var _textAreaHeight:Number = 480;
		private var _title1RowIndex:Number = 6;
		private var _title1Text:RowTextField;
		private var _strtitle1:String ="y-tti.com";
		private var _title2RowIndex:Number = 7;
		private var _title2Text:RowTextField;
		private var _strtitle2:String ="www.y-tti.com";
		private var _titleMotionCompCnt:Number = 0;
		private var _titleMotionCnt:Number = 2;
		private var _delayTimer:Timer;
		
		public function ghost_in_the_shell01()
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			var loadFont:LoadFont = new LoadFont("Font/ArnoPro.swf" , "ArnoPro");
			loadFont.addEventListener(loadFont.FONT_LOADCOMPLETE , font_loadComplete );
			this.addEventListener(this.FONTSET_COMPLETE , setTextField );
			this.addEventListener(this.TEXTSET_COMPLETE , setClickAction );
		}
		
		private function font_loadComplete(e:Event):void {
			ArnoPro = e.target.FontLibrary;
			dispatchEvent(new Event(this.FONTSET_COMPLETE));
		}
		
		private function setTextField(e:Event):void {
			//数字部分
			_txtSprite = new Sprite();
			addChild(_txtSprite);
			
			_txtArray = [];
			var tempHeight:Number =0;
			var row:Number = 0;
			while( tempHeight < _textAreaHeight) {
				var textsize:Number
				var txt:RowTextField;
				switch(row) {
					case _title1RowIndex:
						textsize=30;
						_title1Text = new RowTextField(ArnoPro,textsize);
						txt = _title1Text;
						break;
					case _title2RowIndex:
						textsize=45;
						_title2Text = new RowTextField(ArnoPro,textsize);
						txt = _title2Text;
						break;
					default:
						textsize = (row%2 == 0) ? 32 : 42;
						txt = new RowTextField(ArnoPro,textsize);
				}
				_txtSprite.addChild(txt);
				txt.y = tempHeight;
				txt.SetText(_strChar , _textAreaWidth);
				
				tempHeight += txt.height*0.8;
				_txtArray.push(txt);
				
				row++;
			}
			
			//フィルター
			_txtSprite.filters = [new GlowFilter(0x13a062,0.4,8,8,2,1,false,false) , new BlurFilter(1,1,1)];
			
			//テクスチャー部分
			var bmd:BitmapData = new BitmapData( _txtSprite.width ,_txtSprite.height , true , 0x0);
			var texture:BitmapAsset = new Texture();
			var textureW:Number = texture.width;
			var matrix:Matrix = new Matrix();
			for (var ix:Number=0;ix*textureW < _txtSprite.width ; ix++) {
				for(var iy:Number=0;iy*textureW < _txtSprite.height; iy++) {
					matrix.tx = ix*textureW;
					matrix.ty = iy*textureW;
					bmd.draw(texture,matrix);
				}
			}
			var bm:Bitmap = new Bitmap(bmd);
			addChild(bm);
			
			//マスク
			_txtSprite.cacheAsBitmap =true;
			bm.cacheAsBitmap =true;
			bm.mask = _txtSprite;
			
			dispatchEvent(new Event(this.TEXTSET_COMPLETE));
		}
		
		private function setClickAction(e:Event):void {
			_title1Text.addEventListener(_title1Text.MOTION_COMPLETE , motionComplete );
			_title2Text.addEventListener(_title2Text.MOTION_COMPLETE , motionComplete );
			addEventListener(MouseEvent.CLICK , motionTextField);
		}
		
		private function motionTextField(e:Event):void{
			if(!motionFlg) {
				addEventListener(Event.ENTER_FRAME , render);
				_delayTimer = new Timer(700,1);
				_delayTimer.addEventListener(TimerEvent.TIMER_COMPLETE , delayTimerComplete );
				_delayTimer.start();
			} else {
				removeEventListener(Event.ENTER_FRAME , render);
			}
			
			motionFlg = !motionFlg;
		}
		
		private function delayTimerComplete(e:TimerEvent):void {
			_strCharRatioSpeed = 0.07;
		}
		
		private function render(e:Event):void {
			_strCharRatio -= _strCharRatioSpeed;
			changeTextField();
			
			if(!motionFlg && _strCharRatio < 0){
				_strCharRatio = 1;
				_strCharRatioSpeed = 0;
				this.titleInitClear();
				removeEventListener(Event.ENTER_FRAME , render);
			}
		}
		
		private function changeTextField():void {
			for(var i:Number=0 ; i<_txtArray.length ; i++){
				var txt:RowTextField = _txtArray[i] as RowTextField;
				switch(i) {
					case _title1RowIndex:
						txt.SetMotionText(_strtitle1 ,_strChar, _textAreaWidth , _strCharRatio);
						break;
					case _title2RowIndex:
						txt.SetMotionText(_strtitle2 ,_strChar, _textAreaWidth , _strCharRatio);
						break;
					default:
						txt.SetText(_strChar , _textAreaWidth , _strCharRatio);
				}
				
			}
		}
		
		private function motionComplete(e:Event):void {
			_titleMotionCompCnt++;
			if(_titleMotionCompCnt >= _titleMotionCnt ) {
				motionFlg = false;
				_titleMotionCompCnt = 0;
			}
			
		}
		
		private function titleInitClear():void {
			_title1Text.initClear();
			_title2Text.initClear();
		}
	}
}
